//PogoHammer.cs

//effects
datablock ParticleData(PogoHammerExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "0.5 1 0.5 0.9";
   colors[1]     = "0 1 0 0.0";
   sizes[0]      = 1;
   sizes[1]      = 0.5;
};

datablock ParticleEmitterData(PogoHammerExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PogoHammerExplosionParticle";

   uiName = "PogoHammer Hit";
};

datablock ExplosionData(PogoHammerExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = printFireSound;

   particleEmitter = PogoHammerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 3;
   lightStartColor = "0.3 1 0.5";
   lightEndColor = "0 1 0";

   damageRadius = 1;
   radiusDamage = 15;

   impulseRadius = 2;
   impulseForce = 1500;
};

datablock ExplosionData(PogoHammerMediumExplosion : PogoHammerExplosion)
{
   lightStartRadius = 2;
   lightEndRadius = 4;

   damageRadius = 2;
   radiusDamage = 25;

   impulseRadius = 3;
   impulseForce = 2500;
};

datablock ExplosionData(PogoHammerLargeExplosion : PogoHammerExplosion)
{
   lightStartRadius = 4;
   lightEndRadius = 6;

   damageRadius = 3;
   radiusDamage = 25;

   impulseRadius = 4;
   impulseForce = 4000;
};


//projectile
AddDamageType("PogoHammer",   '<bitmap:add-ons/Weapon_PogoHammer/CI_PogoHammer> %1',    '%2 <bitmap:add-ons/Weapon_PogoHammer/CI_PogoHammer> %1',0.75,1);
datablock ProjectileData(PogoHammerProjectile)
{
   directDamage        = 25;
   directDamageType    = PogoHammerdamage;
   radiusDamageType    = PogoHammerdamage;
   explosion           = PogoHammerExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

datablock ProjectileData(PogoHammerMediumProjectile : PogoHammerProjectile)
{
   directDamage        = 50;
   explosion           = PogoHammerMediumExplosion;
};

datablock ProjectileData(PogoHammerLargeProjectile : PogoHammerProjectile)
{
   directDamage        = 100;
   explosion           = PogoHammerLargeExplosion;
};


//////////
// item //
//////////
datablock ItemData(PogoHammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./PogoHammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Pogo-Hammer";
	iconName = "./icon_PogoHammer";
	doColorShift = false;
	//colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = PogoHammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PogoHammerImage)
{
   // Basic Item properties
   shapeFile = "./PogoHammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PogoHammerItem;
   ammo = " ";
   projectile = PogoHammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   //colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "ChargeA";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "ChargeA";
	stateScript[2]                  = "onChargeA";
	stateAllowImageChange[2]        = false;
	stateWaitForTimeOut[2]		= false;
	stateTimeoutValue[2]            = 0.5;
	stateTransitionOnTriggerUp[2]     = "FireSmall";
	stateTransitionOnTimeout[2]     = "ChargeB";

	stateName[3]			= "ChargeB";
	stateAllowImageChange[3]        = false;
	stateWaitForTimeOut[3]		= false;
	stateTimeoutValue[3]            = 1;
	stateTransitionOnTriggerUp[3]     = "FireMedium";
	stateTransitionOnTimeout[3]     = "ChargeC";

	stateName[4]			= "ChargeC";
	stateAllowImageChange[4]        = false;
	statewaitforTimeOut[4]		= false;
	stateEmitterNode[4]		= "muzzlenode";
	stateEmitterTime[4]		= 0.3;
	StateEmitter[4]			= PogoHammerExplosionEmitter;
	stateTimeoutValue[4]            = 0.2;
	stateTransitionOnTriggerUp[4]   = "FireLarge";

	stateName[5]                    = "FireSmall";
	stateTransitionOnTimeout[5]     = "StopFire";
	stateTimeoutValue[5]            = 0.2;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]		= true;

	stateName[6]                    = "FireMedium";
	stateTransitionOnTimeout[6]     = "StopFire";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFireMedium";
	stateWaitForTimeout[6]		= true;

	stateName[7]                    = "FireLarge";
	stateTransitionOnTimeout[7]     = "StopFire";
	stateTimeoutValue[7]            = 0.2;
	stateAllowImageChange[7]        = false;
	stateSequence[7]                = "Fire";
	stateScript[7]                  = "onFireLarge";
	stateWaitForTimeout[7]		= true;

	stateName[8]                    = "StopFire";
	stateTransitionOnTimeout[8]     = "Ready";
	stateTimeoutValue[8]            = 0.5;
	stateAllowImageChange[8]        = true;
	stateSequence[8]                = "StopFire";
	stateScript[8]                  = "onStopFire";


};

function PogoHammerImage::onChargeA(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playthread(2, armattack);
	Parent::onChargeA(%this,%obj,%slot);
}

function PogoHammerImage::onStopFire(%this, %obj, %slot)
{	
	if(%obj.getDamagePercent() < 1.0)
		%obj.playthread(2, root);
	Parent::onStopFire(%this,%obj,%slot);
}

function PogoHammerImage::onFireMedium(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%spread = 0;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, PogoHammerMediumProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, PogoHammerMediumProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = PogoHammerMediumProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function PogoHammerImage::onFireLarge(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%spread = 0;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, PogoHammerLargeProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, PogoHammerLargeProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = PogoHammerLargeProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}